#include <msp/fs/dir.h>
#include <msp/fs/stat.h>
#include <msp/fs/utils.h>
#include "task.h"

using namespace std;
using namespace Msp;

Task::Task():
	unlink(false)
{ }

void Task::add_file(const FS::Path &f)
{
	files.push_back(f);
}

void Task::set_unlink(bool u)
{
	unlink = u;
}

void Task::prepare()
{
	for(list<FS::Path>::const_iterator i=files.begin(); i!=files.end(); ++i)
	{
		if(FS::exists(*i))
		{
			// If the file exists, the directory it's in must exist too
			FS::unlink(*i);
		}
		else
		{
			FS::Path dir = FS::dirname(*i);
			if(!FS::exists(dir))
				FS::mkpath(dir, 0755);
		}
	}
}
